<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wtk_rights_tickets');
    if(!$perm['r']) die($parser->gt('not_perms'));
    if(!isset($workframe)) die('');

    include_once(SYS_BASE_PATH.'main/classes/wcatalog.class.php');
    class wcat extends wCatalog
    {
        public $perm = array('c' => 0, 'r' => 0, 'u' => 0, 'd' => 0);
        public function _titleframe()
        {
            global $parser;

            $this->title = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wtk_tickets'", '');
            $this->gridframeurl = $parser->makeUrl('fcc_wtk_tickets_list');

            $pars = array();
            $pars['onchange'] = 'reloadgridm()';
            $pars['name'] = 'filter_period';
            $pars['val'] = 1;
            $this->addCell($parser->utils->periodMenu($pars));



            $pars['name'] = 'filter_color';
            $pars['onchange'] = 'reloadgridm()';
            $pars['val'] = 0;
            $pars['colored'] = true;
            $pars['options'] = array($parser->gt('allcolors'));
            $this->addCell($parser->utils->dropdownMenu($pars));

            $this->popup_script = true;
            $pars = array();
            $pars['name'] = 'filter_state';
            $pars['onchange'] = 'reloadgridm()';
            $pars['width'] = 150;
            $pars['val'] = 0;
            $pars['options'] = array($parser->gt('all'),
                                     $parser->gt('formeunresolved',__FILE__),
                                     $parser->gt('formeall',__FILE__),
                                     $parser->gt('icontrolunresolved',__FILE__),
                                     $parser->gt('icontrol'),
                                     $parser->gt('mysunresolved',__FILE__),
                                     $parser->gt('mys'),
                                     );
            $this->addCell($parser->utils->dropdownMenu($pars));

        }


        public function _treeframe()
        {
            global $parser;

            include_once(SYS_BASE_PATH.'main/classes/wajaxtree.class.php');
            $tree = new wAjaxTree();
            $tree->caption = $parser->gt('products', __FILE__);

            $tree->onopendialog = 'hide_list';
            $tree->onclosedialog = 'show_list';

            $tree->q->select('objid');
            $tree->q->lselect('name');
            $tree->q->select('isfolder');
            $tree->q->select('parent');
            $tree->q->select("'' AS prim");
            $tree->q->select('0 AS treetype');
            $tree->q->from('sys_objects');
            $tree->q->where("objid<>'0'");
            $tree->q->where("objtype='wtk_t_dirs_products'");
            $tree->q->where('parent=:parent:');
            $tree->q->lorderby('name');

            $tree->leaf_func = 'leafclick';
            $tree->folder_func = 'leafclick';
            $tree->unselect = true;
            $tree->show();
        }

        public function _gridframe()
        {
            global $parser;
            $filter_state = (isset($_REQUEST['filter_state'])) ? $_REQUEST['filter_state'] : '';
            $filter_period = (isset($_REQUEST['filter_period'])) ? $_REQUEST['filter_period'] : '';
            $filter_color = (isset($_REQUEST['filter_color'])) ? $_REQUEST['filter_color'] : '';
            $cat_id = (isset($_REQUEST['cat_id'])) ? $_REQUEST['cat_id'] : '';
            include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
            $w = new wAjaxGrid();
            $w->edit_table_alias = 'o';

            $w->f = new tickets_models_ticket();
            if($cat_id) $w->caption = $parser->utils->getFieldFromSql("SELECT name_ru FROM sys_objects WHERE objid='".$cat_id."'", '');
                else $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wcrmp_tickets'", '');

            $w->q->select('o.id',  $parser->gt('id'));
            $w->q->select('o.creaton', $parser->gt('createdon'));
            $w->q->lselect('c.name AS cname', $parser->gt('creatby'));
            $w->q->lselect('u.name AS uname', $parser->gt('creatto'));
            $w->q->select('o.title', $parser->gt('name'), array('edit' => $this->perm['u']));
            $w->q->lselect('s.name AS sname', $parser->gt('state'));
            $w->q->lselect('p.name AS pname', $parser->gt('priority'));
            $w->q->lselect('r.name AS rname', $parser->gt('solution'));
            $w->q->select('pr.name AS prname', $parser->gt('product'), array('lang' => 1, 'hide' => $cat_id));
            $w->q->select('o.comments', $parser->gt('scomments'));

            $w->q->from('wtk_tickets o');
            $w->q->from('sys_objects u');
            $w->q->from('sys_objects c');
            $w->q->from('sys_objects s');
            $w->q->from('sys_objects p');
            $w->q->from('sys_objects r');
            $w->q->from('sys_objects pr');
            $w->q->where("o.id<>'0'");
            $w->q->where("o.creatto=u.objid");
            $w->q->where("o.creatby=c.objid");
            $w->q->where("o.state=s.objid");
            $w->q->where("o.priority=p.objid");
            $w->q->where("o.solution=r.objid");
            $w->q->where("o.productid=pr.objid");
            $w->q->orderby('o.id DESC');

            $w->addHidden('filter_period', $filter_period);
            if($filter_period)
            {
                 $per = $parser->utils->getPeriod($filter_period, true);
                 $w->q->where("o.creaton ".$per);
                 $w->f->extra_deleteAll_sql .= "AND (creaton ".$per.")";
            }
            //$w->q->select('o.title', $parser->gt('shortname'), array('edit' => $this->perm['u']));
            $w->rowclass_col = $w->q->select('o.color', $parser->gt('color'), array('hide' => 1));
            $w->addHidden('filter_color', $filter_color);
            if($filter_color)
            {
                $w->q->where("o.color='".$filter_color."'");
                $w->f->extra_deleteAll_sql .= "AND color='".$filter_color."' ";
                $w->f->setFieldVal('color', $filter_color);
            }
            //$w->q->select('o.isprivate', $parser->gt('isprivate'));
		    $w->addHidden('filter_state', $filter_state);
            switch($filter_state)
            {
                case 1:	 $w->q->where("o.creatto='".$u['id']."'");
                         $w->q->where("o.state NOT IN('wtk_t_states_closed')");
                break;
                case 2:	 $w->q->where("o.creatto='".$u['id']."'");
                break;
                case 3:	 $w->q->where("o.monitoring='".$u['id']."'");
                         $w->q->where("o.state NOT IN('wtk_t_states_closed')");
                break;
                case 4:	 $w->q->where("o.monitoring='".$u['id']."'");
                break;
                case 5:	 $w->q->where("o.creatby='".$u['id']."'");
                         $w->q->where("o.state NOT IN('wtk_t_states_closed')");
                break;
                case 6:	 $w->q->where("o.creatby='".$u['id']."'");
                break;
            }
            if($cat_id) $w->q->where("o.productid='$cat_id'");

            $w->addSearchField('o.creaton', $parser->gt('creaton'), 'D');
            $w->addSearchField('o.duedate', $parser->gt('duedate'), 'D');
            $w->addSearchField('o.updateon', $parser->gt('updateon'), 'D');
            $w->addSearchField('o.title', $parser->gt('name'), 'C');
            $w->addSearchField('o.notes', $parser->gt('notes'), 'C');
            $w->addSearchField('o.description', $parser->gt('description'), 'C');
            $w->addSearchField('o.conclusion', $parser->gt('conclusion'), 'C');
            $w->addSearchField('o.email', $parser->gt('email'), 'C');
            $w->addSearchField('o.partid', $parser->gt('partid'), 'C');
            $w->addSearchField('o.creatby', $parser->gt('creatby'), 'sys_users');
            $w->addSearchField('o.creatto', $parser->gt('creatto'), 'sys_users');
            $w->addSearchField('o.monitoring', $parser->gt('monitoring'), 'sys_users');
            $w->addSearchField('o.solution', $parser->gt('solution'), 'wcrmp_t_dirs_sols');
            $w->addSearchField('o.priority', $parser->gt('priority'), 'wcrmp_t_dirs_priorities');
            $w->addSearchField('o.state', $parser->gt('state'), 'wcrmp_t_dirs_states');
            $w->addSearchField('o.product', $parser->gt('product'), 'wcrmp_t_dirs_products');
            $w->addSearchField('o.source', $parser->gt('source'), 'wcrmp_t_dirs_srcs');
            $w->addSearchField('o.category', $parser->gt('category'), 'wcrmp_t_dirs_categs');
            $w->addSearchField('o.comments', $parser->gt('comments'), 'I');

            $w->editing = $this->perm['u'];
            $w->adding = $this->perm['c'];
            $w->copying = $this->perm['c'];
            $w->deleting = $this->perm['d'];
            $w->multiselect = $this->perm['d'];

            $w->cardurl = $parser->makeUrl('wtk_tickets_card');
            $w->addHidden('cat_id', $cat_id);

            $w->show();

        }
    }

    $cat = new wcat();
    $cat->workframe = $workframe;
    $cat->perm = $perm;

    $cat->show();

?>