<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class tickets_models_comments extends wPrototype
{

public function __construct($objtype = '', $id = '')
{
    $this->id = $id;
    parent::__construct('wtk_tickets_com');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
    $this->showformTinymceScript = true;
    $this->richedit_height = 300;
}


protected function _onBeforeInsert()
{
    global $parser;
    $this->setFieldNewVal('userid', $parser->getUserId());
    $this->setFieldNewVal('creaton', $parser->utils->toDate('', true));
}

protected function _onBeforeShowForm()
{
    global $parser;
    if(!$this->id)
    {
        $a = $parser->utils->getFieldsFromSql('SELECT o.creatto, o.state, o.solution, o.monitoring, o.creatby
                                              FROM wtk_tickets o
                                              WHERE (o.id='.$this->getFieldVal('ticketid').')'
                                              , array(0,0,0,''), 'num');
        $this->setFieldVal('newstate', $a[1]);
        $this->setFieldVal('solution', $a[2]);

        if(!$parser->checkRoles(array('wtk_roles_exec','wtk_roles_admin')) or !in_array($parser->getUserId(), array($a[0], $a[3])))
        {
            $this->setFieldAttr('reassigned', 'hide', 1);
            $this->setFieldAttr('solution', 'hide', 1);
        }
        if(!in_array($parser->getUserId(), array($a[0], $a[3], $a[4])))   $this->setFieldAttr('newstate', 'hide', 1);
        if(($parser->getUserId() == $a[4]) and !in_array($parser->getUserId(), array($a[0], $a[3])))
        {
            $ext = '';
            switch($a[1])
            {
                case 'wtk_t_states_closed': $ext = " AND (objid IN('".$a[1]."', 'wtk_t_states_reopen'))"; break;
                default: $ext = " AND (objid IN('".$a[1]."', 'wtk_t_states_closed'))";
            }
            $this->setFieldAttr('newstate', 'extra_pars', $ext);

        }

    } else
    {
        $this->setFieldAttr('reassigned', 'ro', 1);
        $this->setFieldAttr('solution', 'ro', 1);
        $this->setFieldAttr('newstate', 'ro', 1);
        $this->setFieldAttr('description', 'ro', 1);
    }
    $sql = " AND ((objid IN(SELECT DISTINCT r.row_objid FROM sys_obj_array r
WHERE  (r.row_objtype='sys_users')
AND (r.col_objtype='sys_rights_roles')
AND (r.col_objid IN('wtk_roles_exec','wtk_roles_admin')))) OR (objid='sys_superadmin')) ";
    $this->setFieldAttr('reassigned', 'extra_pars', $sql);
    return '';
}

protected function _onInsert()
{
    global $parser;
    $f = new tickets_models_ticket();
    $f->id = $this->getFieldVal('ticketid');
    $f->read();
    if($this->getFieldNewVal('reassigned') and ($this->getFieldNewVal('reassigned') !== $f->getFieldVal('creatto')))
        $f->setFieldNewVal('creatto', $this->getFieldNewVal('reassigned'));
    if($this->getFieldNewVal('newstate') and ($this->getFieldNewVal('newstate') !== $f->getFieldVal('state')))
        $f->setFieldNewVal('state', $this->getFieldNewVal('newstate'));
    if($this->getFieldNewVal('solution') and ($this->getFieldNewVal('solution') !== $f->getFieldVal('solution')))
        $f->setFieldNewVal('solution', $this->getFieldNewVal('solution'));
    $f->update();
    $this->calc(true);
    return '';
}

protected function _onDelete()
{
    $this->calc();
    return '';
}

protected function calc($upd = true)
{
    global $parser;

    $qty = $parser->utils->getFieldFromSql('SELECT COUNT(*) FROM wtk_tickets_com WHERE ticketid='.$this->getFieldVal('ticketid'), 0);
    if($upd) $parser->conn->Execute('UPDATE wtk_tickets SET comments='.$qty.", lastpostid=".$this->id.", lastposttime=".
                                     $parser->utils->getCurrDay().", lastposter='".$parser->conn->escape($parser->getUserId())."'
                                     WHERE id=".$this->getFieldVal('ticketid'));

    return $qty;
}

}

?>