<?php
class tickets_models_reports_registry
{
protected $parser;

public function __construct($parser)
{
    $this->parser = $parser;
}

public function getReport()
{
    $parser = $this->parser;

    ob_start();
    include_once(SYS_BASE_PATH.'main/classes/wreport.class.php');
    $w = new wReport();
    $w->caption = $this->parser->utils->getFieldFromSql("SELECT name_".$this->parser->lang_suff." FROM sys_objects WHERE objid='".$this->parser->pageId."'", '');

    if($w->mode != 'print')
    {
        // Show report filters
        $sec = $w->addSection($parser->gt('main'));
        $w->addReportPar($sec, 'period', $parser->gt('period'), 'period', 0);
        $w->addReportPar($sec, 'grouping', $parser->gt('grouping'), 'select', 0, $parser->gt('sel_no', SYS_BASE_PATH.'main/classes').','.$parser->gt('owner'));

        $sec = $w->addSection($parser->gt('more'));

        $w->addSearchField($sec, 'o.creaton', $parser->gt('creaton'), 'D');
        $w->addSearchField($sec, 'o.duedate', $parser->gt('duedate'), 'D');
        $w->addSearchField($sec, 'o.updateon', $parser->gt('updateon'), 'D');
        $w->addSearchField($sec, 'o.title', $parser->gt('name'), 'C');
        $w->addSearchField($sec, 'o.notes', $parser->gt('notes'), 'C');
        $w->addSearchField($sec, 'o.description', $parser->gt('description'), 'C');
        $w->addSearchField($sec, 'o.conclusion', $parser->gt('conclusion'), 'C');
        $w->addSearchField($sec, 'o.email', $parser->gt('email'), 'C');
        $w->addSearchField($sec, 'o.partid', $parser->gt('partid'), 'C');
        $w->addSearchField($sec, 'o.creatby', $parser->gt('creatby'), 'sys_users');
        $w->addSearchField($sec, 'o.creatto', $parser->gt('creatto'), 'sys_users');
        $w->addSearchField($sec, 'o.monitoring', $parser->gt('monitoring'), 'sys_users');
        $w->addSearchField($sec, 'o.solution', $parser->gt('solution'), 'wtk_t_dirs_sols');
        $w->addSearchField($sec, 'o.priority', $parser->gt('priority'), 'wtk_t_dirs_priorities');
        $w->addSearchField($sec, 'o.state', $parser->gt('state'), 'wtk_t_dirs_states');
        $w->addSearchField($sec, 'o.product', $parser->gt('product'), 'wtk_t_dirs_products');
        $w->addSearchField($sec, 'o.source', $parser->gt('source'), 'wtk_t_dirs_srcs');
        $w->addSearchField($sec, 'o.category', $parser->gt('category'), 'wtk_t_dirs_categs');
        $w->addSearchField($sec, 'o.comments', $parser->gt('comments'), 'I');

        $w->show();
        $output = ob_get_contents();
        ob_end_clean();
        return $output;
    }

    // Print report
    $pars = $w->getParams();
    $u = $parser->utils->getUserInfo();

    $from = ($pars['period1']) ? $parser->conn->DBDate($parser->utils->dateToISOformat($pars['period1'])) : '';
    $to = ($pars['period2']) ? $parser->conn->DBDate($parser->utils->dateToISOformat($pars['period2'])) : '';

    $w->q->select('o.id',  $parser->gt('id'));
    $w->q->select('o.creaton', $parser->gt('createdon'));
    $name_col = $w->q->select('o.title AS otitle', $parser->gt('name'), array('func' => 'open_doccard'));
    $w->q->lselect('p.name AS pname', $parser->gt('priority'));
    $w->q->lselect('pr.name AS prname', $parser->gt('product'));
    $w->q->select('o.comments', $parser->gt('scomments'), array('func' => 'showdetail'));
    $w->rowclass_col = $w->q->select('o.color', $parser->gt('color'), array('hide' => 1));

    $w->q->from('wtk_tickets o');
    $w->q->from('sys_objects u');
    $w->q->from('sys_objects c');
    $w->q->from('sys_objects s');
    $w->q->from('sys_objects p');
    $w->q->from('sys_objects r');
    $w->q->from('sys_objects pr');
    $w->q->where("o.id<>'0'");
    $w->q->where("o.creatto=u.objid");
    $w->q->where("o.creatby=c.objid");
    $w->q->where("o.state=s.objid");
    $w->q->where("o.priority=p.objid");
    $w->q->where("o.solution=r.objid");
    $w->q->where("o.productid=pr.objid");

    if(!$u['super']) $w->q->where("(o.isprivate=0) OR (o.creatby='".$u['id'].
              "') OR (o.creatto='".$u['id'].
              "') OR (o.monitoring='".$u['id'].
              "') OR ((o.creatby<>'".$u['id']."') AND (c.ref1 IN(".$u['subdepartments'].")) AND (c.ref2 IN(".$u['subpositions'].")))");

    $w->q->lselect('c.name AS cname', $parser->gt('creatby'));
    $w->q->lselect('s.name AS sname', $parser->gt('state'));
    $w->q->lselect('u.name AS tname', $parser->gt('creatto'));
    $w->q->lselect('r.name AS rname', $parser->gt('solution'));

    $w->q->extra_where($w->getFilters());
    if($from) $w->q->where("o.creaton>=".$from);
    if($to) $w->q->where("o.creaton<=".$to);

    $w->cardurl = $parser->makeUrl('wtk_tickets_card');
    $w->addCard($name_col, 0, $parser->makeUrl('wtk_tickets_card'));


    switch($pars['grouping'])
    {
        case 0:

        break;
        case 1:
            $w->template = SYS_BASE_PATH.'main/styles/reporter_tpl/tbsgroup1.htm';
            $w->q->orderby('tname');
            $w->pagelen = 30;
            $w->grupfield= 'tname';
        break;
    }

    $w->q->orderby('otitle');

    $w->show();

    $output = ob_get_contents();
    ob_end_clean();
    return $output;
}

}

?>