<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class tickets_models_ticket extends wPrototype
{
protected $_mailed = array();

public function __construct($objtype = '', $id = '')
{
    $this->id = $id;
    parent::__construct('wtk_tickets');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
    $this->showformTinymceScript = true;
    $this->richedit_height = 300;
}


protected function _onBeforeInsert()
{
    global $parser;
    $a = $parser->utils->getFieldsFromSql("SELECT ref1, ref2 FROM sys_objects WHERE objid='".$this->getFieldNewVal('productid')."'", array(0,0), 'num');
    if(!$this->getFieldNewVal('creatto'))
    {
        $resp = $a[0];
        if(!$resp)
        {
            $b = $parser->utils->getUserInfo();
            $resp = $b['curator'];
        }
        if(!$resp) $resp = $parser->gs('wtk_settings_tickets_response');
        if(!$resp) $resp = 'sys_superadmin';
        $this->setFieldNewVal('creatto', $resp);
    }

    if(!$this->getFieldNewVal('monitoring'))
    {
        $resp = $a[1];
        if(!$resp) $resp = $parser->gs('wtk_settings_tickets_monitoring');
        $this->setFieldNewVal('monitoring', $resp);
    }

    $this->setFieldNewVal('creatby', $parser->getUserId());
    $this->setFieldNewVal('creaton', $parser->utils->toDate('', true));
    $this->setFieldNewVal('updateon', $parser->utils->toDate('', true));

    if($this->getFieldNewVal('priority'))
    {
        $d = explode(' ', $this->getFieldNewVal('duetime'));
        if(strlen($d[0]) < 8)
        {
            $b = $parser->utils->getFieldsFromSql("SELECT ref1, flt1 FROM sys_objects WHERE objid='".$this->getFieldNewVal('priority')."'", array(0,0), 'num');
            $term = $parser->utils->shiftDates($parser->utils->toDate('', true), $b[1], $b[0]);
            $this->setFieldNewVal('duetime', $parser->utils->toDate($term, true));
        }
    }
    //$this->setFieldNewVal('duetime', $parser->utils->toDate('', true));

    $this->setFieldNewVal('state', 'wtk_t_states_new');
}

protected function _onBeforeDelete()
{
    global $parser;
    $user = ''.$parser->getUserId();
    if($user != $this->getFieldVal('creatby')) return $parser->gt('itsnotyourticket');
    return '';
}

protected function _onInsert()
{
    global $parser;
    $user = ''.$parser->getUserId();
    if($user != $this->getFieldNewVal('creatto')) $this->notifyUsers($this->getFieldNewVal('creatto'), 'newticketforyou');
    if($user != $this->getFieldNewVal('monitoring')) $this->notifyUsers($this->getFieldNewVal('monitoring'), 'monitoringticketforyou');
    return '';
}

protected function _onDelete()
{
    global $parser;
    $fn = SYS_BASE_PATH.'userdata/modules/tickets/wtk_tickets/'.$this->id;
    if(file_exists($fn)) $parser->utils->removeDir($fn, true);
    return '';
}

protected function _onBeforeUpdate()
{
    global $parser;
    $this->setFieldAttr('updateon', 'ro', 0);
    $this->setFieldAttr('state', 'ro', 0);
    $this->setFieldAttr('solution', 'ro', 0);
    $this->setFieldNewVal('updateon', $parser->utils->toDate('', true));
}

protected function _onUpdate()
{
    global $parser;
    $this->setFieldAttr('updateon', 'ro', 1);
    $this->setFieldAttr('state', 'ro', 1);
    $this->setFieldAttr('solution', 'ro', 1);
    if(in_array('updateon', $this->all_chg_fields) and (sizeof($this->all_chg_fields) == 1)) return '';
    if(sizeof($this->all_chg_fields) < 1) return '';

    $user = ''.$parser->getUserId();
    if(($user != $this->getFieldNewVal('creatto')) and  ($this->getFieldVal('creatto') != $this->getFieldNewVal('creatto')))
    {
        $this->notifyUsers($this->getFieldNewVal('creatto'), 'newticketforyou');
        if($user != $this->getFieldVal('creatto'))
        {
            $this->notifyUsers($this->getFieldVal('creatto'), 'unticketforyou');
        }
    }
    if(($user == $this->getFieldNewVal('monitoring')) and  ($this->getFieldVal('monitoring') != $this->getFieldNewVal('monitoring')))
    {
        $this->notifyUsers($this->getFieldNewVal('monitoring'), 'monitoringticketforyou');
        if($user != $this->getFieldVal('monitoring'))
        {
            $this->notifyUsers($this->getFieldVal('monitoring'), 'unmonitoringticketforyou');
        }
    }

    if($user != $this->getFieldVal('creatby')) $this->notifyUsers($this->getFieldVal('creatby'), 'crticketwaschanged', $this->getFieldNewVal('email'));
    if($user != $this->getFieldVal('creatto')) $this->notifyUsers($this->getFieldVal('creatto'), 'toticketwaschanged');
    if($user != $this->getFieldVal('monitoring')) $this->notifyUsers($this->getFieldVal('monitoring'), 'mnticketwaschanged');

}


protected function _onBeforeShowForm()
{
    global $parser;
    if($this->id)
    {
        $user = ''.$parser->getUserId();
        if(($user != $this->getFieldVal('creatby')) or !in_array($this->getFieldVal('state'), array('0', 'wtk_t_states_new')))
        {
            $this->setFieldAttr('title', 'ro', 1);
            $this->setFieldAttr('isprivate', 'ro', 1);
            $this->setFieldAttr('creatto', 'ro', 1);
            $this->setFieldAttr('monitoring', 'ro', 1);
            $this->setFieldAttr('parent', 'ro', 1);
            $this->setFieldAttr('priority', 'ro', 1);
            $this->setFieldAttr('source', 'ro', 1);
            $this->setFieldAttr('projectid', 'ro', 1);
            $this->setFieldAttr('productid', 'ro', 1);
            $this->setFieldAttr('category', 'ro', 1);
            $this->setFieldAttr('description', 'ro', 1);
            $this->setFieldAttr('duetime', 'ro', 1);
            $this->setFieldAttr('email', 'ro', 1);
            $this->setFieldAttr('partid', 'ro', 1);
            $css = "
            <style type=\"text/css\">
                #td_description {border: solid 1px #888; padding:4px; font-weight:bold;font-size: 13px;}
            </style>
            ";
            $parser->addCSS($css);
        }
        if(!in_array($user, array($this->getFieldVal('creatby'), $this->getFieldVal('creatto'), $this->getFieldVal('monitoring'))))
        {
            $this->setFieldAttr('color', 'ro', 1);
            $this->setFieldAttr('notes', 'ro', 1);
        }
        if(!in_array($user, array($this->getFieldVal('creatto'), $this->getFieldVal('monitoring'))))
        {
            $this->setFieldAttr('conclusion', 'ro', 1);
        }

        if($this->getFieldVal('comments')) $this->setFieldAttr('creatto', 'ro', 1);
        if($this->getFieldVal('parent'))
        $this->setFieldAttr('parent', 'labelfunc', "openWinc('".$parser->makeUrl('wtk_tickets_card')."', '&objid=:value:'); return false;");
    } else
    {
        $this->setFieldVal('isprivate', ($parser->gs('wtk_settings_tickets_private')) ? 1 : 0);
        $this->setFieldVal('productid', $parser->gs('wtk_settings_tickets_product'));
        $this->setFieldAttr('id', 'hide', 1);
        $this->setFieldAttr('creaton', 'hide', 1);
        $this->setFieldAttr('creatby', 'hide', 1);
        $this->setFieldAttr('state', 'hide', 1);
        $this->setFieldAttr('solution', 'hide', 1);
        $this->setFieldAttr('comments', 'hide', 1);
        $this->setFieldAttr('updateon', 'hide', 1);
        $this->setFieldAttr('conclusion', 'hide', 1);
    }

    if(!$parser->checkPerms('wtk_rights_tickets_solve', 'a'))
    {
        $this->setFieldAttr('monitoring', 'ro', 1);
        $this->setFieldAttr('creatto', 'ro', 1);
        $this->setFieldAttr('parent', 'ro', 1);
        //$this->setFieldAttr('priority', 'ro', 1);
        $this->setFieldAttr('source', 'ro', 1);
        $this->setFieldAttr('projectid', 'ro', 1);
        $this->setFieldAttr('duetime', 'ro', 1);
        $this->setFieldAttr('conclusion', 'ro', 1);
        if(!$this->id)
        {
            $this->setFieldAttr('creatto', 'hide', 1);
            $this->setFieldAttr('monitoring', 'hide', 1);
            $this->setFieldAttr('parent', 'hide', 1);
            //$this->setFieldAttr('priority', 'hide', 1);
            $this->setFieldAttr('source', 'hide', 1);
            $this->setFieldAttr('projectid', 'hide', 1);
            $this->setFieldAttr('duetime', 'hide', 1);
        }

    }

    $this->setFieldAttr('productid', 'extra_pars', " AND (bool1=1) "); // Only aviable products
    $sql = " AND ((objid IN(SELECT DISTINCT r.row_objid FROM sys_obj_array r
WHERE  (r.row_objtype='sys_users')
AND (r.col_objtype='sys_rights_roles')
AND (r.col_objid IN('wtk_roles_exec','wtk_roles_admin')))) OR (objid='sys_superadmin')) ";
    $this->setFieldAttr('creatto', 'extra_pars', $sql);
    $this->setFieldAttr('monitoring', 'extra_pars', $sql);
    return '';
}

protected function notifyUsers($to = '', $mess = '', $email = '')
{
    global $parser;
    if(!$to) return;
    if(in_array($to, $this->_mailed)) return;
    $this->_mailed[] = $to;

    $card = "<a href=\"javascript:void(0)\" onclick=\"javascript:openWinc('".$parser->makeUrl('wtk_tickets_card').
                "', '&objid=".$this->id."'); return false;\"> ".$this->id."</a>";

    $messm = $parser->gt($mess, '', $card);
    if($parser->gs('wtk_settings_tickets_intmail', true, $to))  $parser->intMail($to, $messm, false);
    if(!$parser->gs('wtk_settings_tickets_email', true, $to))  return;

    $a = $parser->utils->getUserInfo($to);
    if(!trim($a['email'])) return;


    // Get last comment
    $card = "<a href=\"".$parser->makeUrl('tickets/cards', 'objid='.$this->id, false,true)."\"> ".$parser->config['site_name']."</a>";
    $description = '<b>'.$card.' - '.$parser->gt('ticket').' '.$this->id.'. ';
    $description .= $parser->utils->getFieldFromSql("SELECT name_".$parser->lang_suff." FROM sys_objects WHERE objid='".$this->getFieldNewVal('creatby')."'", '');
    $description .= '. '.$this->getFieldNewVal('title').'.</b><br />';

    $description .= '<b>'.$parser->gt('state').': '.$parser->utils->getFieldFromSql("SELECT name_".$parser->lang_suff." FROM sys_objects WHERE objid='".$this->getFieldNewVal('state')."'", '').'</b><br />';
    if($this->getFieldNewVal('solution'))
    $description .= '<b>'.$parser->gt('solution').': '.$parser->utils->getFieldFromSql("SELECT name_".$parser->lang_suff." FROM sys_objects WHERE objid='".$this->getFieldNewVal('solution')."'", '').'</b><br />';
    $description .= $this->getFieldNewVal('description').'<br /><br />';

    $c = $parser->utils->getFieldsFromSql("SELECT t.id, t.description, u.name_".$parser->lang_suff."
                                           FROM wtk_tickets_com t, sys_objects u
                                           WHERE (u.objid=t.userid)
                                           AND (ticketid=".$this->id.")
                                           ORDER BY t.id DESC",
                                           array(0,'',''), 'num');
    //$c = trim($parser->utils->getFieldFromSql('SELECT description, id FROM wtk_tickets_com WHERE ticketid='.$this->id.' ORDER BY id DESC', ''));
    if(trim($c[1])) $description .= '<b>'.$parser->gt('lastcomment').'.<br />'.$c[2].'</b>.<br />'.$c[1];

    $pars = array('to' => $a['email'],
                  'subject' => strip_tags($parser->gt($mess, '', $this->id)),
                  'message' => $description
                          );
    $parser->utils->sendMail($pars);

    // Extra e-mails
    if(!trim($email)) return;
    $e = explode(',', trim($email));
    for($i = 0; $i < sizeof($e); $i++)
    {
        $pars = array('to' => trim($e[$i]),
                      'subject' => strip_tags($parser->gt($mess, '', $this->id)),
                      'message' => $description
                              );
        $parser->utils->sendMail($pars);
    }
}

}

?>